/*
 * Copyright 2013 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import QtQuick 2.0
import Ubuntu.Components 0.1

TextArea {
    id: textArea

    /* WORKAROUND for but in the SDK:
       https://bugs.launchpad.net/ubuntu-ui-toolkit/+bug/1168006
       which makes the app crash when loading the theme */
    ItemStyle.delegate: Item {}

    signal deletePrevious()

    autoSize: true
    maximumLineCount: 0

    function cursorToEnd() {
        textArea.cursorPosition = textArea.text.length
    }

    Connections {
        target: Qt.inputMethod
        onVisibleChanged: {
            // This event is received by *all* delegates, but we want to defocus
            // only the current one when the OSK disappear.
            // We want to defocus because otherwise when the user clicks again on
            // the text area the OSK will not come up again if the focus is still there.
            if (!Qt.inputMethod.visible && textArea.activeFocus) {
                textArea.focus = false;
            }
        }
    }
}
